package fr.unice.reneviergonin.demoaccelero;

import android.content.Context;
import android.graphics.Point;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.view.Display;
import android.view.Surface;
import android.view.WindowManager;

import java.util.Observable;

/**
 * Created by Philippe on 02/03/2016.
 */
public class Capteur extends Observable implements SensorEventListener {

    Context context;
    Display display;
   Vecteur donnees = new Vecteur();


    private Sensor mAccelerometer;
    private SensorManager mSensorManager;



    private boolean running = false;

    public Capteur(Context c) {
        this.context = c;
        WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
        display = wm.getDefaultDisplay();

        mSensorManager = (SensorManager) context.getSystemService(Context.SENSOR_SERVICE);
        mAccelerometer = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);

    }


    public void stop() {
        mSensorManager.unregisterListener(this);
        running = false;
    }

    public void start() {
        mSensorManager.registerListener(this, mAccelerometer, SensorManager.SENSOR_DELAY_UI);
        running = true;
    }

    public boolean isRunning() {
        return running;
    }



    public int getRotation()  {
        if (display != null) return display.getRotation();
        else return -1;
    }


    @Override
    public void onSensorChanged(SensorEvent sensorEvent) {
        if (sensorEvent.sensor.getType() != Sensor.TYPE_ACCELEROMETER)
            return;


        switch (display.getRotation()) {
            case Surface.ROTATION_0:
                donnees.x = sensorEvent.values[0];
                donnees.y = sensorEvent.values[1];
                break;
            case Surface.ROTATION_90:
                donnees.x = -sensorEvent.values[1];
                donnees.y = sensorEvent.values[0];
                break;
            case Surface.ROTATION_180:
                donnees.x = -sensorEvent.values[0];
                donnees.y = -sensorEvent.values[1];
                break;
            case Surface.ROTATION_270:
                donnees.x = sensorEvent.values[1];
                donnees.y = -sensorEvent.values[0];
                break;
        }
        // z = sensorEvent.values[2];


        setChanged();
        notifyObservers(new Vecteur(donnees));
    }


    // public float []  getDonnees() { return donnees; }
    public float getX() { return donnees.x; }
    public float  getY() { return donnees.y; }

    @Override
    public void onAccuracyChanged(Sensor sensor, int i) {

    }

}
