package fr.unice.reneviergonin.demoaccelero;

import android.app.Activity;
import android.content.Context;
import android.graphics.drawable.Drawable;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.view.Display;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;


public class DemoAccelero extends Activity {

    private Interpreteur controleurVue ;
    private Capteur capteur;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_accelero);

        View v = findViewById(R.id.imageView);

        Drawable image = getResources().getDrawable(R.drawable.fleche2);
        int h = image.getIntrinsicHeight();
        int w = image.getIntrinsicWidth();

        capteur = new Capteur(this);
        controleurVue = new Interpreteur(v, w, h);

        capteur.addObserver(controleurVue);
    }


    public void launchStop(View button) {
        /* listener du bouton, association faite dans le xml */
        if (capteur.isRunning()) capteur.stop();
        else capteur.start();
    }


    /* stop en cas de quit... */
    /* il faudra relancer l'écoute en cliquant sur le bouton */
    protected void onPause() {
        super.onPause();
        capteur.stop();
    }
    protected void onStop() {
        super.onStop();
        capteur.stop();
    }

}
