package fr.unice.reneviergonin.demoaccelero;

import android.app.Instrumentation;
import android.view.View;
import android.widget.RelativeLayout;

import java.util.Observable;
import java.util.Observer;

/**
 * Created by Philippe on 02/03/2016.
 */
public class Interpreteur implements Observer {


    final float MARGE = 0.3f;
    final int PAS = 1;
    final int PAS_MAX = 15;
    private int img_height;
    private int img_width;

    // les 3 valeurs de l'accélérometre
    int accelerationX = 0;
    int accelerationY = 0;



    View animee;
    private RelativeLayout.LayoutParams params;
    private final RelativeLayout parent;


    public Interpreteur(View animee, int width, int height) {
        this.animee = animee;

        this.img_width = width;
        this.img_height = height;

        /* pour le déplacement de la fleche, cela se fait avec les marges */
        params = new RelativeLayout.LayoutParams(img_width,img_height);
        params.leftMargin =0;
        params.topMargin = 0;

        animee.setLayoutParams(params);
        parent = (RelativeLayout) animee.getParent() ;
    }


    @Override
    public void update(Observable observable, Object data) {
        
        if ((data != null) && (data instanceof  Vecteur)) {
            float x,y ;
            Vecteur donneesRecues = (Vecteur) data;
            x = donneesRecues.x;
            y = donneesRecues.y;

            if (x < - MARGE) {
                accelerationX = Math.max(-PAS_MAX, accelerationX-1);
            }
            else if (x >  MARGE) {
                accelerationX = Math.min(PAS_MAX, accelerationX+1);
            }
            else {
                if (accelerationX > 0) accelerationX = accelerationX-1;
                else if (accelerationX < 0) accelerationX = accelerationX+1;
            }
            params.leftMargin = Math.max(0, Math.min(params.leftMargin - PAS * accelerationX, parent.getMeasuredWidth() - img_width));



            if (y >  MARGE) {
                accelerationY = Math.min(PAS_MAX, accelerationY+1);
            }
            else if (y < - MARGE) {
                accelerationY = Math.max(-PAS_MAX, accelerationY-1);
            }
            else {
                if (accelerationY > 0) accelerationY = accelerationY-1;
                else if (accelerationY < 0) accelerationY = accelerationY+1;
            }

            params.topMargin = Math.max(0, Math.min(params.topMargin + PAS * accelerationY, parent.getMeasuredHeight() - img_height));

            animee.setLayoutParams(params);
            animee.invalidate();
        }

    }
}
